(*---------------------------------------------------------------------------*)
program ip4XLP;
{$apptype console}
{ip4xlpclp2ip𓝍B 2002.9.5}
{procedure feasibleǉAcompute_lp_solution, compute_branch_solution, datain C 2000.7.24}
{iK@𓱓B2018.5.15}
uses
   SysUtils;
const
   imax=1000; jmax=1000; print_keta=80; iprint = 0;      {revised on 2002.9.5}
   mbranch = 30000;//jmax;
   spc10 = '          ';
   debug = false;
   zero = '0.   '; //for bfm-style '.'-> '0.000' 2012.10.12
   big = 1.0e9;
   epsiron = 1.0e-6;//1.0e-6;
const
   knt_max=30000; //30000;
type
   vptr = ^v;
   v = array[0..jmax] of double; {1->0, 2002.9.5}
   tptr = array[0..imax] of vptr; {1->0, 2002.9.5}
   
   sptr = ^s;
   s = array[1..jmax,1..2] of double;
   solution_ptr = array[0..mbranch] of sptr;
   
   wk = array[1..jmax] of double;
   wk_ptr = array[0..mbranch] of ^wk;
   optwk_ptr = ^wk_ptr;
   
   pjoken_array = ^joken_array;
   joken_array = array[1..jmax,1..2] of string[2];
   joken_matrix = array[0..mbranch] of pjoken_array;
var
   //ifile:text;
   joken:joken_matrix;
   tjoken:array[1..jmax] of string[2];
   title:string;
   //fname:string;
   pname : array[1..jmax] of string;
   cname : array[1..imax] of string;
   //iK@ŕKvȕϐ̐錾
   w : array[1..jmax] of double; //⏕֐̌W
   lp_w : array[1..jmax] of double; //⏕֐̌W
   //܂
   atta,ierr:integer;
   i,iprsv,ii,jj,keta,m1,n1:integer;
   js,je,id,koho,jp,ip,ltt,target,tuika:integer;
   ige,m,mline,n,mn,min,ie,ks,branch:integer;
   noans:boolean;
   ipos:array[1..jmax]of integer;
   lp_lt,lt:array[1..imax]of integer;
   lp_num,num:array[1..jmax]of integer;
   nom,noe,kg:array[1..jmax]of integer;
   kolum:array[1..(print_keta div 10)-1] of integer;
   a,bk_optv,dif,cmin,rhs,seisu,slmm,ta,ulimit,wa:double;
   lp_t:tptr;
   t:tptr;
   optv:array[0..mbranch] of double;
   optwk:optwk_ptr;
   prsv_kg:solution_ptr;
   tprsv_kg:array[1..jmax] of double;
   ce:array[1..(print_keta div 10)-1] of double;
   dfile : text;

   rieki : array[0..jmax] of real;
   seiyaku : array[0..jmax] of real; //for bfm-style 2012.10.12
   
(* title:title *)
(* joken:add condition *)
(* t:simplex tableau *)
(* kk:line no. of input data *)
(* ll:row no. of input data *)
(* a:value of input data *)
(* lt:variable number of basic variable *)
(* num:variable number of non-basic variable *)
(* ks:number of integer variable *)
(* nom:row number of lower limit *)
(* noe:row number of equal limit *)
(* kg:column number of integer variable *)

(*---------------------------------------------------------------------------*)
procedure send_end_msg;
begin
   assign(dfile, 'XLP_DMY.$$$');
   rewrite(dfile);
   close(dfile);
end;

(*---------------------------------------------------------------------------*)
function fn_test_zero(dmy : double):boolean;
begin
   if (-epsiron < dmy) and (dmy < epsiron) then 
      fn_test_zero := true
   else
      fn_test_zero := false;
end;

(*---------------------------------------------------------------------------*)
procedure dprint;                 (* for debug, print all element of tableau *)
var
   m1,n1:integer;
   i,j,jj:integer;
begin
   m1:=1+m+tuika;
   n1:=1+n+min+ige;
   keta:=10;
   je:=0;
   writeln(title);
   writeln(m:3,n:3,ie:3,min:3);
   write('  w[]     ':1);//write(spc10);
   for j:=1 to n+min+ks do begin
      write(w[j]:10:3);
   end;
   writeln;
   while (je<n1) do begin
      js:=je+1;
      je:=je+keta;
      if (je>n1) then
         je:=n1;
      write(spc10);
      for jj:=js to je do
         write(num[jj]:10);
      writeln;
      for i:=1 to m1 do begin
         write(lt[i]:5,'     ');
         for jj:=js to je do
            if fn_test_zero(t[i]^[jj]) then write(zero:10)
            else write(t[i]^[jj]:10:3);
         writeln;
      end;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure dprint_15;      (* for debug, print(15keta) all element of tableau *)
var
   m1,n1:integer;
   i,jj:integer;
begin
   keta := 8;
   m1:=1+m+tuika;
   n1:=1+n+min+ige;
   je:=0;
   writeln(title);
   while (je<n1) do begin
      js:=je+1;
      je:=je+keta;
      if (je>n1) then
         je:=n1;
      write(spc10);
      for jj:=js to je do
         write(num[jj]:15);
      writeln;
      for i:=1 to m1 do begin
         write(lt[i]:5,'     ');
         for jj:=js to je do
            if fn_test_zero(t[i]^[jj]) then write(zero:15)
            else write(t[i]^[jj]:15:3);
         writeln;
      end;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure datain;
(* input data on framework of model *)
label
   1000, 2000, 3000;
var
   i,j:integer;
   str1 : string[1];
   str2 : string[2];
   str80 : string;
begin
   readln(title);
   readln(m, n, ie, min);
   (* equality limit : ie *)
   if (ie>=1) then begin
      for i:=1 to ie do begin  readln(noe[i]); end;
   end;
   (* minimum limit : min *)
   if (min>=1) then begin
      for i:=1 to min do begin readln(nom[i]); end;
   end;
   (* input name of process and constraint *)
   while true do begin
      read(i); if i = 30000 then goto 1000;
      readln(str80); delete(str80,1,1); pname[i] := str80;
   end;
   1000:
   
   while true do begin
      read(i); if i = 30000 then goto 2000;
      readln(str80); delete(str80,1,1); cname[i] := str80;
   end;
   2000:

   {count the number of integer variable}
   ks := 0;
   for i := 1 to n do begin
      str1 := pname[i,1];
      str2 := pname[i,1] + pname[i,2];
      if (str1 = '*') or (str2 = '') then begin
         ks := ks + 1;
         kg[ks] := i;
      end;
   end;
   
   ierr:=0;
   if n + min + ks > jmax - 1 then begin
      writeln('***** vZX{t񎮁{vZX ',jmax-1:3,
              '  łȂ΂Ȃ܂B');
      ierr := 1;
   end;
   
   if m + ks > imax - 1 then begin
      writeln('***** 񎮂̐{vZX ',imax-1:3,
              '  łȂ΂Ȃ܂B');
      ierr := 1;
   end;
   
   if ierr > 0 then begin
      send_end_msg;
      halt;
   end;
   
   m1:=m+1;
   n1:=n+1;
   mn:=m+n;
   noans:=false;

   (* initial tableau *)
   for i:=1 to m1+ks do
      for j:=1 to n1+min+ks do
         t[i]^[j]:=0.0;

   (* technical and return coefficient, value of constraint *)
   while true do begin
      read(i); if i = 30000 then goto 3000;
      readln(j, a);
      if (i>m) or (j>n) then begin
         write('***** sԍ邢͗ԍ傫܂B-----  ');
         writeln(i:5,j:5,a:10:3);
         ierr := -1;
      end else begin
         i:=i+1; j:=j+1; {because in ip4xlp the base of array of tableau is 1}
         t[i]^[j]:=a;
      end;
   end;
   3000:
   
   if (ierr=-1) then begin
      send_end_msg;
      halt;
   end;
   
   (* slack  variable on lower restraint line *)
   if (min<>0) then begin
      for i:=1 to min do begin
         ii:=nom[i]+1;
         jj:=n1+i;
         t[ii]^[jj]:=-1.;
      end;
   end;

   //vWƒ萔̕ۑ 2012.10.12
   for i := 1 to m do
      seiyaku[i] := t[i+1]^[1];
   for j := 1 to n do
      rieki[j] := t[1]^[j+1];

   //vW̕ۑ
   //for j:=1 to n do pprofit[j] := t[1]^[j+1];
   
end;

(*---------------------------------------------------------------------------*)
procedure build_initial_solution;
(* build model *)
var
   i,j:integer;
begin
   (* nunbering of basic variable *)
   lt[1]:=0;
   for i:=2 to imax - 2 do
      lt[i]:=(i-1)+20000;
      
   (* numbering of non basic variable *)
   for  j:=1 to jmax - 2 do begin
      if (j<=n1) then num[j]:=j-1;
      if (j>n1) then num[j]:=j-n1+10000;
   end;
   
   (* value of criterion *)
   for j:=1 to n1+min do begin
      t[1]^[j]:=-t[1]^[j];
   end;
   
   //iK@s鏀F⏕֐̓
   for j := 1 to n1 + min + ks + 1 do
      w[j] := 0;
   {񎮂̃XbNϐ̌W}
   for i := 1 to min do 
      t[1+nom[i]]^[n1+i] := -1.0;
   {[ł͏ȗĂlוϐ̗`ɕϊ}
   {̐lוϐ̗F(n1+min)Eɂ}
   for i := 1 to min do
      for j := 1 to n1 + min do
         w[j] := w[j] - t[1+nom[i]]^[j];
   {̐lוϐ̗F(n1+min)Eɂ}
   for i := 1 to ie do
      for j := 1 to n1 + min do          
         w[j] := w[j] - t[1+noe[i]]^[j];
   //܂
      
end;

(*---------------------------------------------------------------------------*)
procedure initialize_branch_solution_list;
(* initialize list of branch solution *)
(* optv:optimal value          boptwk:working level *)
(* joken:kind of add condition *)
(* ipos:position of integer var in lp solution[10000>:=: basis, *)
(* 20000<: non-basis] *)
var
   i,j:integer;
begin
   for i:=0 to mbranch do begin
      optv[i]:=0.;
      //for j:=1 to jmax do begin
      for j:=1 to n do begin
         optwk^[i]^[j]:=0.;
      end;
      for j:=1 to ks do begin
         joken[i]^[j,1]:='no';
         joken[i]^[j,2]:='no';
         prsv_kg[i]^[j,1]:=0.;
         prsv_kg[i]^[j,2]:=0.;
      end;
   end;
   for i:=1 to ks do begin
      tjoken[i]:='no';
      tprsv_kg[i]:=0.;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure tprint1;
(* print all element of tableau *)
var
   i,jj:integer;
begin
   je:=0;
   writeln('*****  *****  ',title);
   while (je<n1) do begin
      js:=je+1;
      je:=je+keta;
      if (je>n1) then
         je:=n1;
      
      write('        ':9);
      for jj:=js to je do
         write(jj-1:10);
      writeln;
      
      write('         ':9);
      for jj:=js to je do
         if jj = 1 then
            write(spc10)
         else
            write('  ':2,copy(pname[jj-1],1,8):8);
      writeln;
      
      write('         ');
      for jj:=js to je do
         if jj = 1 then
            write(spc10)
         else
            write('  ':2,copy(pname[jj-1],9,8):8);
      writeln;
      
      for i:=1 to m1 do begin
         if i = 1 then
            write(i-1:2,' ':1,'y|b':6)
         else
            write(i-1:2,' ':1,copy(cname[i-1],1,6):6);
         for jj:=js to je do
            if fn_test_zero(t[i]^[jj]) then write(zero:10)
            else write(t[i]^[jj]:10:3);
         writeln;
      end;
   
   end;
end;

(*---------------------------------------------------------------------------*)
procedure tprint2;
(* print only element of non zero *)
var
   i,j,ii:integer;
begin
   writeln(title);
   for i:=1 to m1 do begin
      if (id=0) then writeln;
      writeln(i-1:5,'    ');
      id:=0;
      for j:=1 to n1 do begin
         if (t[i]^[j]>epsiron) or (t[i]^[j]<-epsiron) then begin
            id:=id+1;
            kolum[id]:=j-1;
            ce[id]:=t[i]^[j];
            if (id=keta) then begin
               write('         ');
               for ii:=1 to keta do
                  write(kolum[ii]:5,ce[ii]:10:3);
               writeln;
               id:=0;
            end;
         end;
      end;
      if (id<>0) then begin
         write('         ');
         for ii:=1 to keta do
            write(kolum[ii]:5,ce[ii]:10:3);
         writeln;
      end;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure sweep;
var
   i,j:integer;
   wpivot : double;
begin
   ta:=t[ip]^[jp];
   (* transform  sweeping row *)
   for j:=1 to n1+min+ige do
      t[ip]^[j]:=t[ip]^[j]/ta;
   t[ip]^[jp]:=1.0/ta;
   (* transform  non-sweeping row *)
   for i:=1 to m1+tuika do begin
      if (i<>ip) then begin
         ta:=t[i]^[jp];
         for j:=1 to n1+min+ige do
            t[i]^[j]:=t[i]^[j]-t[ip]^[j]*ta;
         t[i]^[jp]:=0.0-t[ip]^[jp]*ta;
      end;
   end;
   
   //iK@F⏕֐̌W̌vZ
   wpivot := w[jp];
   for j := 1 to n1 + min + ige do
      w[j] := w[j] - t[ip]^[j] * wpivot;
   w[jp] := 0.0 - t[ip]^[jp] * wpivot; {pivotting colunm }
   //܂
   
   (* exchange label of basic variable and non-basic variable *)
   ltt:=lt[ip];
   lt[ip]:=num[jp];
   num[jp]:=ltt;

end;

(*--------------------------------------------------------------------------*)
//iK@FPiǨvZ
function first_phase : boolean;
label
   4000;
var
   i, j : integer;
begin
   while true do begin
      (* sweeping column *)
      jp := 0;
      //cmin := -epsiron / 100.0;{add " / 100.0" on 2010.10.13}
      cmin := -epsiron;
      for j := 2 to n1 + min + ige do begin
         if w[j] < cmin then begin
            cmin := w[j];
            jp := j;
         end;
      end;
      if jp = 0 then goto 4000;
      //ip := fn_ipivot(jp);
      
      (* sweeping row *)
      ip := 0;
      cmin:=1.0e20;
      for i:=2 to m1+tuika do begin
      //for i:=2 to m1 do begin
         ta:=t[i]^[jp];
         if (ta>epsiron) then begin
            rhs:=t[i]^[1]/ta;
            if (rhs<cmin) then begin
               cmin:=rhs;
               ip:=i;
            end;
         end;
      end;
      
      sweep;
      
      //write(tcon, ':':1);
   end;
   
   4000:
   
   if w[1] < -epsiron then begin
      if debug then writeln('s܂B w = ', w[1]:5:3);
      first_phase := false;
   end else begin                              {feasible}
      if debug then writeln('s܂B w = ', w[1]:5:3);
      first_phase := true;
   end;
end;

(*---------------------------------------------------------------------------*)
function kitei(jj:integer):integer;
(* if integer variable is basic variable then kitei<=10000 else kitei>20000 *)

var
   i,j:integer;
begin
   for i:=2 to m1+tuika do
      if (lt[i]=jj) then begin (* be basic variable *)
         kitei:=i;
         exit;
      end;

   for j:=2 to n1+min+ige do
      if (num[j]=jj) then begin (* not be basic variable *)
         kitei:=j+20000;
         exit;
      end;
      
   kitei:=0;
   
end;

(*--------------------------------------------------------------------------*)
function  feasible:boolean;{                                   2000.7.21}
begin
   feasible := true;
   if (w[1] < -epsiron) then feasible := false;
   exit;
{
   //ȉAiK@̊ɍ폜
   for i:= 1 to ie do begin
      tmp := kitei(noe[i]+20000);
      if (tmp<=10000) and (t[tmp]^[1]>epsiron) then begin
         feasible := false;
         exit;
      end;
   end;
   //for i := 1 to min do begin
   for i := 1 to min+ige do begin
      tmp := kitei(nom[i]+20000);
      if (tmp<=10000) and (t[tmp]^[1]>epsiron) then begin
         feasible := false;
         exit;
      end;
   end;
   //܂
}
end;      

(*--------------------------------------------------------------------------*)
procedure  compute_lp_solution;
(* compute lp-solution *)
var
   i,j,knt:integer;
begin

   //iK@FPiǨvZ
   first_phase;

   for knt:=1 to mn*5 do begin
      (* sweeping column *)
      jp := 0;
      cmin:=-epsiron;
      { for j:=2 to n1+min+ige do begin }
      for j:=2 to n1+min do begin
         ta:=t[1]^[j];
         if (w[j] < epsiron) and (ta < cmin) then begin
            cmin := ta;
            jp := j;
         end;
      end;
      (* lp-solution was gained *)
      if jp = 0 then begin
         if not feasible then begin
            writeln('***** s\܂ *****');
            send_end_msg;
            halt;
            noans:=true;
         end else
            noans:=false;
         exit;
      end;
      {continue computing}
      (* sweeping row *)
      ip := 0;
      cmin:=1.0e20;
      { for i:=2 to m1+tuika do begin }
      for i:=2 to m1 do begin
         ta:=t[i]^[jp];
         if (ta>epsiron) then begin
            rhs:=t[i]^[1]/ta;
            if (rhs<cmin) then begin
               cmin:=rhs;
               ip:=i;
            end;
         end;
      end;
      if ip=0 then begin
         (* infinite  solution *)
         writeln('***** ł *****');
         writeln('***** ĉ *****');
         send_end_msg;
         halt;
      end;
      
      (* sweeping *)
      (* pivot element is t[i]^[,jp] *)
      sweep;
      
   end;
   (* too  many  corners *)
   writeln('***** ̌₪܂ *****');
   send_end_msg;
   halt;
end;

(*--------------------------------------------------------------------------*)
procedure  compute_branch_solution;
(* compute branch-solution *)
var
   i,j,knt:integer;
begin
   noans:=false;

   //iK@FPiǨvZ
   first_phase;

   //fobOpR[h
   //writeln('came');
   
   for knt:=1 to mn*5 do begin
      (* sweeping column *)
      jp := 0;
      cmin:=-epsiron;
      for j:=2 to n1+min+ige do begin
         ta:=t[1]^[j];
         if (w[j] < epsiron) and (ta < cmin) then begin
            cmin := ta;
            jp := j;
         end;
      end;
      (* lp-solution was gained *)
      if jp = 0 then begin
         if not feasible then begin
            noans:=true;
         end else
            noans:=false;
         exit;
      end;
      {continue computing}
      (* sweeping row *)
      ip := 0;
      cmin:=1.0e20;
      for i:=2 to m1+tuika do begin
         ta:=t[i]^[jp];
         if (ta>epsiron) then begin
            rhs:=t[i]^[1]/ta;
            if (rhs<cmin) then begin
               cmin:=rhs;
               ip:=i;
            end;
         end;
      end;
      if ip = 0 then begin
         (* infinite  solution *)
         
         noans := true;
         
         {
         writeln('***** infinite solution *****');
         writeln('***** ĉ *****');
         send_end_msg;
         halt;
         }
      end;
      
      (* sweeping *)
      (* pivot element is t[i]^[,jp] *)
      sweep;

      //fobOpR[h
      //writeln('knt = ',knt:1);dprint_15;

   end;

   (* too  many  corners *)
   noans := true;
   {
   writeln('***** too many corners *****');
   send_end_msg;
   halt;
   }
end;

(*---------------------------------------------------------------------------*)
procedure preserve_lp_solution;
(* preserve lp solution *)
(* store lp-solution on memory *)
var
   i,j:integer;
begin
   (* tableau *)
   for i:=1 to m1 do
      for j:=1 to n1+min do
         lp_t[i]^[j]:=t[i]^[j];
   for i:=1 to m1 do
      lp_lt[i]:=lt[i];
   for j:=1 to n1+min do
      lp_num[j]:=num[j];
   for j:=1 to n1+min do
      lp_w[j]:=w[j];
      
   (* preserve working-level *)
   (* ipos:position of integer variable in lp solution *)
   (* [10000:=<:basis, 20000<:non-basis] *)
   (* optwk:preserve working-level of double variable *)
   for j:=0 to n do
      optwk^[1]^[j] := 0.000;
   for i:=2 to m1 do
      if (lt[i]<=10000) then
         optwk^[1]^[lt[i]]:=t[i]^[1];
   (* preserve optimal value *)
   optv[1]:=t[1]^[1];
   for i:=1 to ks do
      prsv_kg[1]^[i,1]:=optwk^[1]^[kg[i]];
end;

(*---------------------------------------------------------------------------*)
procedure add_constraint_to_model(ip:integer);
(* modify model[add new restraint condition] *)
var
   idmy,j:integer;
begin
   t[ip]^[1]:=seisu;
   idmy:=kitei(kg[target]); //Yϐ̒P̕\ł̈ʒul

      //fobOpR[h
      //dprint_15;
      //writeln('modified line number = ',idmy:1);

      if debug then begin writeln('before making it basic form');dprint;end;

   if (idmy<20000) then (* Yϐ is basic variable *)
      for j:=1 to n1+min+ige do
         t[ip]^[j]:=t[ip]^[j]-t[idmy]^[j]
   else (* Yϐ is not basic variable *)
      t[m1+tuika]^[idmy-20000]:=1;
      
   if debug then begin writeln('after making it basic form');dprint;end;
      
end;

(*---------------------------------------------------------------------------*)
procedure addlt;
(* numbering added variable in lt and num *)
var
   i,j:integer;
begin
   (* numbering lt *)
   //for i:=m1+1 to m1+tuika do
   for i:=m1+1 to imax-2 do
      lt[i]:=(i-1)+20000;
   (* numbering num *)
   if (ige>0) then
      //for j:=n1+min+1 to n1+min+ige do
      for j:=n1+min+1 to jmax-2 do
         num[j]:=(j-n1)+10000;
end;

(*---------------------------------------------------------------------------*)
procedure dual;
var
   i,j,knt:integer;
begin
   for knt:=1 to mn*5 do begin
      (* test t[i]^[1]<0 *)
      cmin:=-epsiron;
      for i:=2 to m1+tuika do
         if (t[i]^[1]<cmin) then begin
            ip:=i;
            cmin:=t[i]^[1];
         end;
      (* all t[i]^[1] >= 0 *)
      if (cmin>=-epsiron) then begin
         (* noans: flag of not feasible *)
         noans:=false; //feasible in the case
         exit;
      end;
      (* any of t[i]^[1] < 0 *)
      rhs:=1.0e20;
      for j:=2 to n1+min+ige do
         if (t[ip]^[j]<-epsiron) then begin
            wa:=t[1]^[j]/t[ip]^[j];
            wa:=abs(wa);
            if (wa<rhs) then begin
               rhs:=wa;
               jp:=j;
            end;
         
            //dual͕l̒萔𖳂̂ڂȂ̂Ŏs\
            //ۏ؂͍lȂĂ悢Bcompute_branch_solutionfirst_phase̖
            //̂ɂŁu⏕֐̌W̃`FbNv͕sv
{            if (w[j] < epsiron) and (wa < rhs) then begin
               //fn_jpivot := j;
               //exit;
               rhs := wa;
               jp := j;
            end;
            //܂
            }
         
         end;
      if (rhs>=1.0e20) then begin
         noans:=true;
         exit;
      end;
      
      sweep;
      
   end;
   
   writeln('***** too many corners in dual *****');
   send_end_msg;
   halt
end;

(*---------------------------------------------------------------------------*)
procedure extract_ip_solution;
var
   i,j:integer;
begin
   for i := 2 to m1 + ks do begin
      if lt[i] > 20000 then begin
         lp_t[3]^[lt[i]-20000] := t[i]^[1];  (* rest of restraint *)
         lp_t[4]^[lt[i]-20000] := 0;         (* shadow price *)
      end else if lt[i] < 10000 then begin
         lp_t[1]^[lt[i]] := t[i]^[1];        (* working level *)
         lp_t[2]^[lt[i]] := 0;               (* shadow price *)
      end;
   end;
   for j := 2 to n1 + min + ige do begin
      if num[j] > 20000 then begin
         lp_t[4]^[num[j]-20000] := t[1]^[j];  (* shadow price *)
         lp_t[3]^[num[j]-20000] := 0;         (* rest of restraint *)
      end else if num[j] < 10000 then begin
         lp_t[2]^[num[j]] := t[1]^[j];        (* shadow price *)
         lp_t[1]^[num[j]] := 0;               (* working level *)
      end;
   end;
   (* modify shadow price of equality limit for penalty method *)
   //if (ie>=1) then
      //for i:=1 to ie do
         //lp_t[4]^[noe[i]] := lp_t[4]^[noe[i]] - big;
   (* modify shadow price of minimum limit for penalty method *)
   //if (min>=1) then
      //for i:=1 to min do
         //lp_t[4]^[nom[i]] := lp_t[4]^[nom[i]] - big;
end;

(*---------------------------------------------------------------------------*)
procedure preserve_branch_solution(order:integer);
(* preserve branch solution in optv & optwk *)
var
   i,j:integer;
begin
   branch:=branch+1;
   if (branch>mbranch) then begin
      writeln('***** too many branches *****');
      send_end_msg;
      halt
   end;
   //œK̕ۑ
   optv[branch]:=t[1]^[1];
   //extract_ip_solution; //œK(ғAcʋyѐ݉i)𒊏o
   for j:=0 to n do
      optwk^[branch]^[j] := 0.000;
   for i:=2 to m1+tuika do
      if (lt[i]<10000) then optwk^[branch]^[lt[i]]:=t[i]^[1];
   //for j:=1 to n do
      //optwk^[branch]^[j]:=lp_t[1]^[j];
   
   {IP̑Ҕ𕪎}ɓ]L}
   for i:=1 to ks do begin
      joken[branch]^[i,1]:=joken[0]^[i,1];
      prsv_kg[branch]^[i,1]:=prsv_kg[0]^[i,1];
      joken[branch]^[i,2]:=joken[0]^[i,2];
      prsv_kg[branch]^[i,2]:=prsv_kg[0]^[i,2];
   end;
   

(*   writeln('target = ',target:1);
   
   {2}̐VK̐́A܂IP̏ɖ߂}
   if order = 2 then  begin
      joken[branch]^[target,1]:=joken[0]^[target,1];
      prsv_kg[branch]^[target,1]:=prsv_kg[0]^[target,1];
      joken[branch]^[target,2]:=joken[0]^[target,2];
      prsv_kg[branch]^[target,2]:=prsv_kg[0]^[target,2];
   end;
*)
   {ɏ璷Ȑ񂪂Ήĕۑ}
   //for i:=1 to ks do begin
   for i:=target to target do begin //ǉ鐮ϐɌ肷
      if joken[branch]^[i,1]='no' then begin
         //̐Ȃꍇ
         joken[branch]^[i,1]:=tjoken[i];
         prsv_kg[branch]^[i,1]:=tprsv_kg[i];
//if knt=3 then writeln('-----------------------------------------------1');
      end else begin
         if joken[branch]^[i,2] = 'no' then begin
         //̐P̏ꍇ(P̂)
            if joken[branch]^[i,1] <> tjoken[i] then begin //ǉPƈقȂ
               joken[branch]^[i,2] := tjoken[i];
               prsv_kg[branch]^[i,2] := tprsv_kg[i];
//if knt=3 then writeln('-----------------------------------------------2');
            end else begin                                //ǉ
               if tjoken[i] = 'le' then begin
                  if tprsv_kg[i] < prsv_kg[branch]^[i,1] then prsv_kg[branch]^[i,1] := tprsv_kg[i]
//if knt=3 then writeln('-----------------------------------------------3');
               end else begin//'ge'
                  if tprsv_kg[i] > prsv_kg[branch]^[i,1] then prsv_kg[branch]^[i,1] := tprsv_kg[i]; 
//if knt=3 then writeln('-----------------------------------------------4');
               end;
            end;
         end;
         if joken[branch]^[i,2]<>'no' then begin
         //̐Q̏ꍇ(PƑQ)
            if joken[branch]^[i,1] = tjoken[i] then begin //ǉPƓ
               if tjoken[i] = 'le' then
                  if tprsv_kg[i] < prsv_kg[branch]^[i,1] then prsv_kg[branch]^[i,1] := tprsv_kg[i]
               else //'ge'
                  if tprsv_kg[i] > prsv_kg[branch]^[i,1] then prsv_kg[branch]^[i,1] := tprsv_kg[i];
               //end; 
            end;
            if joken[branch]^[i,2] = tjoken[i] then begin //ǉQƓ
               if tjoken[i] = 'le' then
                  if tprsv_kg[i] < prsv_kg[branch]^[i,2] then prsv_kg[branch]^[i,2] := tprsv_kg[i]
               else //'ge'
                  if tprsv_kg[i] > prsv_kg[branch]^[i,2] then prsv_kg[branch]^[i,2] := tprsv_kg[i];
            end;
         end;
      end;
   end;
   
end;

(*---------------------------------------------------------------------------*)
procedure remove;
(* remove newly added or modified condition on first solution *)
var
   i,j,idmy:integer;
begin
   (* slack var of added condition formula is not in basis *)
   idmy:=mline-1+20000;
   for i:=2 to m1+tuika do
      if (lt[i]=idmy) then begin
         (* delete mline *)
         ip:=i;
         for j:=1 to n1+min+ige do
            t[i]^[j]:=0;
         exit;
      end;
   (* slack var of added condition formula is in basis *)
   (* transport to non-basis *)
   for j:=2 to n1+min+ige do
      if (num[j]=idmy) then begin
         jp:=j;
         rhs:=1.0e20;
         cmin:=-epsiron;
         for i:=2 to m1+tuika do 
            if (t[i]^[j]<cmin) then begin
               wa:=t[i]^[1]/t[i]^[j];
               wa:=abs(wa);
               if (wa<rhs) then begin
                  rhs:=wa;
                  ip:=i;
               end;
            end;
      end;
      
   sweep;
   
   (* delete mline *)
   for j:=1 to n1+min+ige do
      t[ip]^[j]:=0;
end;

(*---------------------------------------------------------------------------*)
procedure kprint(k:integer);
var
   j:integer;
begin
   writeln;
   writeln('œKl(', k:1, ')', optv[k]:12:3);
   bk_optv:=optv[k];           (*for kosokuna shudan(line 696,738)*)
   for j:=1 to n do begin
      if j = 1 then begin
         write('ғ        ',j:3,pname[j]:16);
         if fn_test_zero(optwk^[k]^[j]) then writeln(zero:10)
         else writeln(optwk^[k]^[j]:10:3);
      end else begin
         write('                ',j:3,pname[j]:16);
         if fn_test_zero(optwk^[k]^[j]) then writeln(zero:10)
         else writeln(optwk^[k]^[j]:10:3);
      end;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure print_int_condition(i:integer);
var
   j:integer;
const
   spc10='          ';
begin
   for j:=1 to ks do begin //ϐ̒ʂԍ
      if j=1 then write('ϐ',kg[j]:4) else write(kg[j]:10);
   end; writeln;
   for j:=1 to ks do begin //P̐͏
      if joken[i]^[j,1]<>'no' then
         write(joken[i]^[j,1]:10) else write(spc10:10);
   end; writeln;
   for j:=1 to ks do begin //P̐̐l
      if joken[i]^[j,1]<>'no' then
         write(prsv_kg[i]^[j,1]:10:3) else write(spc10:10);
   end; writeln;
   for j:=1 to ks do begin //Q̐͏
      if joken[i]^[j,2]<>'no' then
         write(joken[i]^[j,2]:10) else write(spc10:10);
   end; writeln;
   for j:=1 to ks do begin //Q̐̐l
      if joken[i]^[j,2]<>'no' then
         write(prsv_kg[i]^[j,2]:10:3) else write(spc10:10);
   end; writeln;
end;

(*---------------------------------------------------------------------------*)
procedure print_ip_solution;
var
   //keta:integer;
   i,j:integer;
begin
   //keta:=((print_keta - 12) div 30);
   writeln(title:1);
   writeln('œKlF ',',',optv[koho]:12:3);
   bk_optv:=optv[koho];           (*for kosokuna shudan(line 696,738)*)
   writeln('"",vZX,vW,ғ,݉i'); //for bfm-style 2012.10.12
   for j:=1 to n do begin
      write(' ':5,j:3,',"',pname[j]:1,'",');
      if fn_test_zero(rieki[j]) then write(zero:16,',') //for bfm-style 2012.10.12
      else write(rieki[j]:16:3,',');
      if fn_test_zero(lp_t[1]^[j]) then write(zero:16,',') //for bfm-style 2012.10.12
      else write(lp_t[1]^[j]:16:3,',');
      if fn_test_zero(lp_t[2]^[j]) then writeln(zero:16)
      else writeln(lp_t[2]^[j]:16:3);
   end;
   writeln('"",,,c,݉i'); //for bfm-style 2012.10.12
   for i:=1 to m do begin
      write(' ':5,i:3,',"',cname[i]:1,'",');
      if fn_test_zero(seiyaku[i]) then write(zero:16,',') //for bfm-style 2012.10.12
      else write(seiyaku[i]:16:3,',');
      if fn_test_zero(lp_t[3]^[i]) then write(zero:16,',') //for bfm-style 2012.10.12
      else write(lp_t[3]^[i]:16:3,',');
      if fn_test_zero(lp_t[4]^[i]) then writeln(zero:16)
      else writeln(lp_t[4]^[i]:16:3);
   end;
end;

(*---------------------------------------------------------------------------*)
function ip_solution_or_not(koho:integer):boolean;
var
   i:integer;
begin
   ip_solution_or_not := true;
   for i:=1 to ks do begin
      if abs(int(optwk^[koho]^[kg[i]]+0.5)-optwk^[koho]^[kg[i]])>epsiron then begin
         ip_solution_or_not := false;
         exit;
      end;
   end;
end;

(*---------------------------------------------------------------------------*)
procedure compute_ip_solution;
var
   tcon : text;
   i,j,k:integer;
   knt:integer;
   joken_sign:string[2];
   debug_opt: double; //for debug
begin
   branch:=1;
   assign(tcon, 'con');
   rewrite(tcon);
   writeln(tcon,'  IPvZł':1);
   for knt:=1 to knt_max do begin
      if (branch<1) then begin
         //writeln('***** no branch *****');
         writeln('***** IP͂܂ *****');
         exit;
      end;
      if debug then begin writeln;writeln(' knt = ',knt:1);writeln;end;
      write(tcon,'':1);
      (* IP̑I *)
      cmin := -(big);
      for i:=1 to branch do
         if (optv[i]>cmin) then begin
            cmin:=optv[i];
            koho:=i;
            debug_opt:=cmin; //for debug
         end;

      //fobOpR[h
      //writeln; writeln(' ',knt:1,' '); writeln;
      if debug then begin     (* print koho-kai *)
         writeln;
         for i:= 1 to branch do kprint(i); writeln;
         writeln( '*****  *****');
         kprint(koho);
      end;

      //fobOpR[h
      if debug then print_int_condition(koho);

      atta:=0;
      tuika:=0;
      ige:=0;

      //LP̒P̕\IP̒P̕\쐬B
      //LPɁAIPɕtĂ鐮񎮂tB
      for i:=1 to ks do begin
         if debug then begin writeln(' kg(',i:1,') = ',kg[i]:1);end;
         target:=i;
         for k:=1 to 2 do begin
            joken_sign:=joken[koho]^[i,k];
            if joken_sign <> 'no' then begin
               seisu:=prsv_kg[koho]^[i,k];
               tprsv_kg[i]:=seisu;
               (* IPɐݒ肳Ă鐮𕜌 *)

               (* ̏ꍇ *)
               if (joken_sign='le') then begin
                  tjoken[i]:='le';
                  tuika:=tuika+1;
                  add_constraint_to_model(m1+tuika);

               (* ̏ꍇ *)
               end else if (joken_sign='ge') then begin
                  tjoken[i]:='ge';
                  tuika:=tuika+1;
                  
                  ige:=ige+1;
                  nom[min+ige]:=kg[i]; //2018.3.13 ̈ꗗ֒ǉo^B
                  t[m1+tuika]^[n1+min+ige]:=-1.;
                  
                  add_constraint_to_model(m1+tuika);
                  
                  (* `ێ邽߂ɕ⏕֐C *)
                  for j:=1 to n1+min+ige do
                     w[j]:=w[j]-t[m1+tuika]^[j]*1;
                  
               end;
            end;
         end;
      end;
      

      //fobOpR[h
      //writeln('(IP)');dprint_15;

      //IPIPȂvZIB

      If ip_solution_or_not(koho) then begin //IPIPۂ`FbN
         writeln(tcon);
         //addlt; //2018.3.19 comment out
         //IPꗗɕۑĂ͉̂ғȂ̂ŁA
         //IPČvZđSĂ̌ʂ߂B
         dual;
         compute_branch_solution;
         {dprint;}
         extract_ip_solution;
         //ғ̕␳
         //IP̉ғƁAIPƔ肳ꂽ̍ČvZ̉ғ
         //̈Ⴂ݂ꍇB
         //̈Ⴂ́A|ovZ̏ԂႤƂ琶B
         for j:=1 to n do
            lp_t[1]^[j] := optwk^[koho]^[j]; //IPł̉ғ]L
         
         print_ip_solution;
         if debug then begin
            writeln('***** IP܂B *****');
         end;
         exit;
      end;
      
      //IPIPł͂Ȃ̂ŁAvZpB
      
      //ǉB
      //IP̍ŏIP̕\ČB
      (* numbering of added variable *)
      addlt;(* ------------- necessary ?????????????????????????? 2018.3.13 *)
      
      //dual; (* dual method *)
      
      (* run keisan *)
      //if (not noans) then begin

      //fobOpR[h
      //   writeln('---------LE0 ',knt:1);
         
         //compute_branch_solution;
      //end;

      //fobOpR[h
      //IP̍ŏIP̕\vgB
      //writeln(' IP̍Čł    knt = ',knt:1);
      //dprint_15;

      //܂A1̕}vZB(* compute first branch solution *)
      
      //fobOpR[h
      //writeln; writeln(' ',knt:1,'-1 '); writeln;

      (* VlłȂϐɐݒ肷 *)
      for i:=1 to ks do begin
         target:=i;
         //if abs(int(optwk^[koho]^[kg[i]]+0.5)-optwk^[koho]^[kg[i]])>epsiron then begin
         if abs(round(optwk^[koho]^[kg[i]])-optwk^[koho]^[kg[i]])>epsiron then begin
            atta:=-1;
            tuika:=tuika+1;
            //seisu:=int(optwk^[koho]^[kg[i]]+epsiron);
            //seisu:=int(optwk^[koho]^[kg[i]]);
            seisu:=int(optwk^[koho]^[kg[i]]+epsiron);

      //fobOpR[h
      //writeln;
      //writeln('target integer var = ',target:1,'   ',optwk^[koho]^[kg[i]]:5:3);
      //writeln;
      //dprint_15;

            add_constraint_to_model(m1+tuika);

            (* mline: modified line *)
            mline:=m1+tuika;
            ulimit:=seisu;
            iprsv:=i;
            tprsv_kg[i]:=seisu;
            tjoken[i]:='le';

            break;
         end;
      end;
      
      for i:=1 to ks do begin
         {IP̑SĂ̐ꎞҔ}
         joken[0]^[i,1]:=joken[koho]^[i,1];
         prsv_kg[0]^[i,1]:=prsv_kg[koho]^[i,1];
         joken[0]^[i,2]:=joken[koho]^[i,2];
         prsv_kg[0]^[i,2]:=prsv_kg[koho]^[i,2];
      end;

      //fobOpR[h
      //dprint_15;


      if debug then
         writeln('ɐݒ肳ꂽϐ̐':1,tuika:5);

      (* numbering of added variable *)
      addlt;(* ------------- necessary ?????????????????????????? 2018.3.13 *)

      //fobOpR[h
      //dprint_15;

      (* IPꗗ폜āAP炷 *)
      if (koho=branch) then begin
         for j:=1 to n do
            optwk^[koho]^[j]:=0;
         for j:=1 to ks do begin
            joken[koho]^[j,1]:='no';
            prsv_kg[koho]^[j,1]:=0;
            joken[koho]^[j,2]:='no';
            prsv_kg[koho]^[j,2]:=0;
         end;
         optv[koho]:=0;

      end else begin
         for i:=koho to branch-1 do begin
            optv[i]:=optv[i+1];
            for j:=1 to n do
               optwk^[i]^[j]:=optwk^[i+1]^[j];
            for j:=1 to ks do begin
               joken[i]^[j,1]:=joken[i+1]^[j,1];
               prsv_kg[i]^[j,1]:=prsv_kg[i+1]^[j,1];
               joken[i]^[j,2]:=joken[i+1]^[j,2];
               prsv_kg[i]^[j,2]:=prsv_kg[i+1]^[j,2];
            end;
         end;
         optv[branch]:=0;
         for j:=1 to n do
            optwk^[branch]^[j]:=0;
         for j:=1 to ks do begin
            joken[branch]^[j,1]:='no';
            prsv_kg[branch]^[j,1]:=0;
            joken[branch]^[j,2]:='no';
            prsv_kg[branch]^[j,2]:=0;
         end;
      end;

      branch:=branch-1;
      
      (* compute branch solution *)
      (* dual method *)
      dual;

      //fobOpR[h
      //dprint_15;

      (* run keisan *)
      //if (not noans) then begin
      
      //fobOpR[h
      //   writeln('---------LE1 ',knt:1);
      if debug then begin writeln('Tableau for first branch solution');dprint;end;
      compute_branch_solution;
      if debug then dprint;
      //end;

      //fobOpR[h
      //dprint_15;

      (* add to branch solution *)
      //if (not noans) then begin
      if feasible then begin
      
      //fobOpR[h
      //   writeln('---------LE2 ',knt:1);
      
         preserve_branch_solution(1);
         
      //fobOpR[h
      //end else begin
      //   writeln('z= ',t[1]^[1]:5:3);
      //   print_int_condition(branch);
      //   dprint_15;
      
      end;
         
      (* compute second branch solution *)
      
      //fobOpR[h
      //writeln; writeln(' ',knt:1,'-2 '); writeln;

      (* 1̕}vZ邽߂ɐݒ肵菜 *)
      remove;
      (* ɉݒ肵āA2̕}vZ *)
      tjoken[iprsv]:='ge';
      seisu:=ulimit+1;
      tprsv_kg[iprsv]:=seisu;
      ige:=ige+1;
      
      nom[min+ige]:=kg[iprsv]; //2018.3.13
      
      t[ip]^[n1+min+ige]:=-1.;
      (* replace with modified model *)
      target:=iprsv;
      ipos[target]:=kitei(kg[target]);
      add_constraint_to_model(ip);
      (* modify w-function, to keep basic form *)
      for j:=1 to n1+min+ige do
         w[j]:=w[j]-t[ip]^[j]*1;
      (* numbering added variable in num *)
      num[n1+min+ige]:=min+ige+10000;

      //fobOpR[h
      //dprint_15;

      dual; (* dual method *)

      //fobOpR[h
      //dprint_15;

      (* run keisan *)
      //if (not noans) then begin

      //fobOpR[h
      //   writeln('---------GE1 ',knt:1);
         
      if debug then begin writeln('Tableau for second branch solution');dprint;end;
      compute_branch_solution;
      if debug then dprint;
         
      //end;

      //fobOpR[h
      //dprint_15;

      //if (not noans) then begin
      if (feasible) then begin

      //fobOpR[h
       //  writeln('---------GE2 ',knt:1);
       //  print_int_condition(branch);
         
         preserve_branch_solution(2);
         
      //fobOpR[h
      //   print_int_condition(branch);
         
      //fobOpR[h
      //end else begin
      //   writeln('z= ',t[1]^[1]:5:3);
      //   print_int_condition(branch);
      //   dprint_15;
         
      end;

   //fobOpR[h
   //if debug then begin
      //writeln('times = ',knt:1,'  optimal_value = ',debug_opt:5:3,'  koho = ',koho:1);
      //ꗗ
   //   writeln; writeln(' ̃Xg   knt = ',knt:1);
   //   for i:= 1 to branch do begin
   //      kprint(i);
   //      print_int_condition(i);
   //   end;
   //end;


      (* copy saved lp solution to tableau variable(t[] etc) *)
      for i := 1 to m1 + tuika do
         for j := 1 to n1 + min + ige do
            t[i]^[j]:=lp_t[i]^[j];
      for i := 1 to m1 + tuika do
         lt[i]:=lp_lt[i];
      for j := 1 to n1 + min + ige do
         num[j]:=lp_num[j];
      for j := 1 to n1 + min + ige do
         w[j] := lp_w[j];
         
   end;
   
   writeln('***** the number of searching is over the maximum *****');
   close(tcon);
end;

(*--------------------------- main -----------------------------------------*)
begin
   if debug then writeln('==================================== s  ',DateTimeToStr(Now));
   ige:=0;
   tuika:=0;
   keta:=(print_keta div 10)-1;
   for i := 1 to imax do new(lp_t[i]);
   for i := 1 to imax do new(t[i]);
   for i := 0 to mbranch do new(joken[i]);                    {1998.6.30}
   for i := 0 to mbranch do new(prsv_kg[i]);
   if prsv_kg[mbranch] = nil then begin
      writeln('***** [Ȃ̂ŁCsł܂B*****');
      send_end_msg;
      halt;
   end;
   datain;
   getmem(optwk, sizeof(optwk_ptr) * (mbranch + 1));
   for i := 0 to mbranch do begin
      getmem(optwk^[i], sizeof(double) * (n + 1));
   end;
   if iprint = 1 then     (* print table *)
      tprint1;
   build_initial_solution;
   initialize_branch_solution_list;
   (* compute lp solution *)
   compute_lp_solution;
   (* preserve lp-solution *)
   preserve_lp_solution;
   (* branch computation begin *)
   compute_ip_solution;
   if debug then
      for i := 1 to branch do kprint(i);
   send_end_msg;
end.
